{$V-}
Uses DOS;
Type
  PBufC = ^TBufC;
  TBufC = Array [1..$FFFF] Of Char;
  PMsgH = ^TMsgH;
  TMsgH = Record
            Version,                      { Packet version (2)}
            ONode,                        {   Originating node}
            DNode,                        {   Destination node}
            ONet,                         {    Originating net}
            DNet,                         {    Destination net}
            Attr,                         {        FTS1 status}
            Cost       : Word;             {    Cost of message}
          End;
Const
  Ramk = '';
Var
  P              : PBufC;
  PktS           : SearchRec;
  MH             : PMsgH;
  InD, OutD      : String;
  F              : File;
  TXT            : Text;
  L, SM, L1      : Word;
  FSize, NumTxt  : LongInt;
  MesCount, X, Y : Byte;
  Time,
  Subj,
  OName,
  DName          : PChar;
  
Function BufPos (PB: PBufC; Offs, Size: Word; CaseS: Boolean; S: String): Word;
{ 㭪   PB^ ப S.
 ࠬ:
           PB    - 㪠⥫  ⮪ ,  . ந室 .
           Offs  - ᬥ饭 (  Offset(PB^)).
           Size  -  ⪠ .
           CaseS - true-ࠧ  false- ࠧ ॣ.
           S     - ப  ᪠.
  頥:
           0 - ப S  ,   ப. }
Label
  L1, L2;
 Var
   I: Word;
   J: Byte;
 Begin
   BufPos := 0;
   If S [0] = #0 Then Exit;
   If Offs > Size Then Exit;
   If CaseS Then
     For I := offs To Size Do
     Begin
       If PB^ [I] = S [1] Then
       Begin
         For J := 2 To Byte (S [0] ) Do If PB^ [I + j - 1] <> S [J] Then Goto L1;
         BufPos := I;
         Exit;
       End;
       L1:
     End
   Else
     For I := offs To Size Do
     Begin
       If UpCase (PB^ [I] ) = UpCase (S [1] ) Then
       Begin
         For J := 2 To Byte (S [0] ) Do
           If UpCase (PB^ [I + j - 1] ) <> UpCase (S [J] ) Then Goto L2;
         BufPos := I;
         Exit;
       End;
       L2:
     End;
 End;

Function MaxNum (FileMask: String): LongInt;
{頥 ᨬ  䠩.
 ࠬ:
          FileMask - ப  ᪠ 䠩.
 頥:
          -1 - 䠩 室騩   FileMask  .
 ਬ: ᫨  ४ਨ :\  䠩 0.TXT, 1.TXT, 3.TXT, 
           MaxNum('C:\*.TXT')  3.}
 Const
   M: LongInt = - 1;
 Var
   L: LongInt;
   SRec: SearchRec;
   Code: Integer;
   S, S1: String;
 Begin
   MaxNum := - 1;
   FindFirst (FileMask, Archive, SRec);
   While DosError = 0 Do
   Begin
     FSplit (SRec. Name, S1, S, S1);
     Val (S, L, Code);
     If (Code = 0) And (M < L) Then Begin MaxNum := L; M := L; End;
     FindNext (SRec);
   End;
 End;

Procedure Help;
Begin
  WriteLn ('Usage  : PKT2UNIT <PktDir> <UnitDir>');
  WriteLn ('Example: PKT2UNIT C:\T-MAIL\FILES\ C:\T-MAIL\FILES\UNIT\');
  Halt (1);
End;

Function GetX: Byte; Assembler;
Asm
  mov    AH, 0Fh
  Int    10h
  mov    AH, 3
  Int    10h
  mov    AL, DL
End;

Function GetY: Byte; Assembler;
Asm
  mov    AH, 0Fh
  Int    10h
  mov    AH, 3
  Int    10h
  mov    AL, DH
End;

Procedure GotoXY (X, Y: Byte);
Begin
  Asm
    mov   AH, 0Fh
    Int   10h
    mov   AH, 2
    mov   DH, Y
    mov   DL, X
    Int   10h
  End;
End;

Function ToS (W: LongInt): String;
Var
  S: String;
Begin
  Str (W, S);
  ToS := S;
End;

Procedure ClrScr; Assembler;
Asm
  mov AX, 2
  Int 10h
  mov AL, 3
  Int 10h
End;


Begin
  ClrScr;
  WriteLn ('PKT2UNIT, ver 1.0, Copyright 1996 by Kirill Kutejnikov.');
  WriteLn ('FIDO: 2:5030/329.5 AKA /72.111 AKA /136.49', #13, #10); 
  If ParamCount <> 2 Then Help;
  OutD := ParamStr (2);
  If OutD [Byte (OutD [0] ) ] <> '\' Then OutD := OutD + '\';
  NumTxt := MaxNum (OutD + '*.PAS');
  Inc (NumTxt);
  InD := ParamStr (1);
  If InD [Byte (InD [0] ) ] <> '\' Then InD := InD + '\';
  FindFirst (InD + '*.PKT', Archive, PktS);
  While DosError = 0 Do
  Begin
    Assign (F, InD + PktS. Name);
    Reset (F, 1);
    FSize := FileSize (F);
    If FSize > $FFFF Then FSize := $FFFF Else FSize := FSize- $3A;
    WriteLn (InD + PktS. Name);
    MesCount := 0;
    Write ('Message:');
    X := GetX;
    Y := GetY;
    Seek (F, $3A);
    GetMem (P, FSize);
    Repeat
      BlockRead (F, P^, FSize, L);
      If L <> FSize Then Halt (99);
      MH := PMsgH (P);
      L := 1 + SizeOf (MH^);
      Time := PChar (@P^ [L] );
      L := BufPos (@P^ [1], L, FSize, True, #0);
      If L = 0 Then Break; Inc (L);
      DName := PChar (@P^ [L] );
      L := BufPos (@P^ [1], L, FSize, True, #0);
      If L = 0 Then Break; Inc (L);
      OName := PChar (@P^ [L] );
      L := BufPos (@P^ [1], L, FSize, True, #0);
      If L = 0 Then Break; Inc (L);
      Subj := PChar (@P^ [L] );
      
      L := BufPos (@P^ [1], L, FSize, True, #0);
      If L = 0 Then Break;
      Inc (L); SM := L;
      L := BufPos (@P^ [1], L, FSize, True, #0);
      If L = 0 Then Break; Inc (L);
      If GetX = 0 Then 
      Begin
        Write ('Message:');
        X := GetX;
        Y := GetY;
      End;
      GotoXY (X, Y);
      Inc (MesCount);
      Write (ToS (MesCount): 3);
      Seek (F, FilePos (F) - (FSize- L) - 1);
      If FileSize (F) - FilePos (F) < FSize Then FSize := FileSize (F) - FilePos (F);
      If (BufPos (@P^ [1], SM, L, False, 'UNIT') <> 0) And
         (BufPos (@P^ [1], SM, L, False, 'END.') <> 0) And
         (BufPos (@P^ [1], SM, L, False, 'IMPLEMENTATION') <> 0) And
         (BufPos (@P^ [1], SM, L, False, 'INTERFACE') <> 0) 
      Then
      Begin
        WriteLn (' - UNIT found. :)');
        Assign (TXT, OutD + ToS (NumTxt) + '.PAS');
        Rewrite (TXT);
        WriteLn (TXT, Ramk);
        WriteLn (TXT, 'Time:', Time);
        WriteLn (TXT, 'From:', OName);
        WriteLn (TXT, '  To:', DName);
        WriteLn (TXT, 'Subj:', Subj);
        WriteLn (TXT, Ramk);
        Dec (SM);
        Repeat
          L1 := SM + 1;
          SM := BufPos (P, SM, L, True, #$D);
          If SM <> 0 Then P^ [SM] := #0;
          WriteLn (TXT, PChar (@P^ [L1] ) );
        Until SM = 0;
        Close (TXT);
        Inc (NumTxt);
      End;
      If (P^ [L] = #0) And (P^ [L + 1] = #0) Then L := 0
      Else L := 1;
    Until L = 0;
    FSize := FileSize (F);
    If FSize > $FFFF Then FSize := $FFFF Else FSize := FSize- $3A;
    FreeMem (P, FSize);
    WriteLn;
    Close (F);
    WriteLn ('PKT ok.');
    FindNext (PktS);
  End;
End.